{-
% cv. 11 ; na 3.5.2017 (St) ; Jan Hric
% v. 1.1.1

% Obsah: cv11:
- datove typy pro binarni stromy z prednasky
- lookup z prednasky, jako pouziti Maybe a
- mapTree2: map pro Tree2
  - ... a testovaci data
- cv: (leva) rotace BVS
- cv: BVS na usporadany seznam
- cv: takeWhileT: odseknuti horni casi stromu podle fnc. parametru
  - (cv:) odseknuti podle hloubky 
  - (pridani hloubky)
- pruchod a ocislovani stromu zleva
  - obsahuje predavani stravoveho parametru
--- nestihli jsme:
- vyhledavani klice v BVS
  - lookup pro BVS
- prace s Maybe:
  - safeHead: bezpecne odebrani hlavy seznamu
  - maybe na seznam
  - mapMaybe, mapEither
- (nasobeni matic)
- (splnitelnost batohu: zda ma instance reseni)

; pripadne prejmenovat na *.hs , 
(neni urceno jako .lhs)

-}

{-
-- vzor

> filter1 :: (a -> Bool) -> [a] -> [a]
> filter1 _ []     = []
> filter1 f (x:xs) = if f x then x:filter1 f xs
> 			    else   filter1 f xs

test:
filter1 even [1,2,3,4,5]
-}


-- z prednasky:

-- data Bool = False | True	-- v prelude

-- data Maybe a = Nothing | Just a
-- data Either a b = Left a | Right b

data Tree a = Leaf a 
            | Branch (Tree a) (Tree a) 
			deriving (Eq,Ord,Show,Read)
data Tree2 a = Void 
            | Node (Tree2 a) a (Tree2 a)
			deriving (Eq,Ord,Show,Read)
data Tree3 a b = Leaf3 b
            | Branch3 (Tree3 a b) a (Tree3 a b)
			deriving (Eq,Ord,Show,Read)
  -- Tree3 s "explicitnimi" externimi listy

lookup1 :: Eq a => a -> [(a,b)] -> Maybe b
lookup1 _ []  = Nothing
lookup1 k ((k1,v):xs) 
  | k == k1   = Just v
  | otherwise = lookup1 k xs

-- lookup1 2 [(1,11),(2,12),(3,13)]
-- lookup1 4 [(1,11),(2,12),(3,13)]

{-
Q: Hodi se nektery ze stromu na implementaci BVS? (Binarni Vyhledavaci Strom, s klici a hodnotami)
Q: Hodi se nektery ze stromu na implementaci binarni haldy?

Q: Odpovida struktura rekurze mergesortu nekteremu ze stromu?
Q: Odpovida struktura rekurze quicksortu nekteremu ze stromu?
-}

mapTree2 :: (a->b) -> Tree2 a -> Tree2 b
mapTree2 _f Void         = Void
mapTree2  f (Node l x r) = Node 
                             (mapTree2 f l)
                             (f x)
                             (mapTree2 f r)

-- programatorsky trik, pro kratsi a prehlednejsi zapis
mapTree2' :: (a->b) -> Tree2 a -> Tree2 b
mapTree2' f tr = m tr
  where m Void = Void
        m (Node l x r) = Node (m l) (f x) (m r)

-- pomocna funkce (m :: Tree2 a -> Tree2 b) pouziva (f :: a-> b) z nadrazeneho kontextu,
--	ale nema ji jako explicitni argument. 
--  1. Fci m nemuzeme primo volat (protoze neni na nejvyssi urovni) a teda nehrozi "nepredani" 
--	funkcionalniho parametru
--  2. Hakersky koutek: Prekladac fci m parametr f prida, kdyz ji presouva z lokalniho kontextu 
--	do hlavniho kontextu. Nasledne (upravena) m ma vsechno, co potrebuje, v argumentech
--	a proto je cista (bez sideefektu)


-- testovaci data:
tree2a = Node (Node Void 1 Void)
              2
              (Node Void 3 Void)

-- testy:
-- mapTree2 (+10) tree2a
-- mapTree2' (*10) tree2a


{-
Naprogramujte:

0. lRotace :: Tree2 a -> Tree 2
-- pouze vykonny kod; ze se ma pouzit (a jde pouzit) leva nebo prava rotace, uz vime

lRotace (...pred) = ...po
lRotace _x        = _x	-- nemelo by se vyuzivat, ale zachytna podminka je pro blbovzdornost

-- Poznamka programatora: Nepisu blbovzdorne programy. Protoze kdyz blbovzdorny program spadne ....
--   :-)

      2                    1
     / \                  / \
    1   C   <- lRotace   A   2
   / \                      / \
  A   B                    B   C

1. bvs2Srt :: Tree2 a -> [a]
bvs2Srt/1 vypise BVS v infixnim poradi, tj. usporadane.
-- Funkce nepotrebuje tridovy kontext (Ord =>), protoze uz prvky stromu neporovnava.
-- Vyuziva poradi prvku ze stromu

bvs2Srt Void = undefined  -- doprogramovat
bvs2Srt (Node l x r) = undefined

-- abstrakce (fold): pruchodT: jak se zpracovavaji stromy, je dano fcionalnimi parametry
-- pruchodT :: ...

2. takeWhileT :: (a -> Bool) -> Tree2 a -> Tree2 a
Funkce vraci "horni" prvky stromu (nejbliz koreni), pro ktere plati podminka.
-}

takeWhileT :: (a -> Bool) -> Tree2 a -> Tree2 a
--takeWhileT p Void = undefined  -- nahradit
--takeWhileT p (Node l x r) = undefined
takeWhileT p Void = Void  
takeWhileT p (Node l x r) 
  | p x  = Node (takeWhileT p l) x (takeWhileT p r) 
  | True = Void


-- testy, po doprogramovani
-- 	jinak: undefined vyvola vyjimku
-- takeWhileT even tree2a  	== Node Void 2 Void
-- takeWhileT odd  tree2a  	== Void 
-- takeWhileT (<3) tree2a	== Node (Node Void 1 Void) 2 Void

-- 2a.
-- Podminka testuje vrcholy stromu samostatne a bez ohledu na polohu/kontext.
-- Pokud chceme napr. useknout strom v pevne hloubce, muzeme do stromu pridat hloubku (:: Int), 
-- volat takeWhileT/2 a odebrat hloubku
-- transformace: Tree a ~pridejHloubku~> Tree (a,Int) ~takeWhileT~> Tree (a,Int) ~mapTree2~> Tree a
-- doprogramovat
takeHl :: Int -> Tree2 a -> Tree2 a
--takeHl n tr =  undefined
takeHl n tr = mapTree2 fst (takeWhileT (\(_,hl) -> hl<=n) (pridejHloubku 1 tr))

-- pouzivame fst z prelude: 
-- fst :: (a,b) -> a
-- fst (a,b) = a

-- Pro pridani hloubky nestaci mapTree2, potrebujeme trochu obecnejsi funkci. 
-- Pri jeste vetsi abstrakci dalsi funkcionalni parametr (zde: \hl -> hl+1) transformuje stavovou 
-- informaci.
pridejHloubku :: Int -> Tree2 a -> Tree2(a,Int)
pridejHloubku hl Void         = Void
pridejHloubku hl (Node l x r) = Node (pridejHloubku (hl+1) l) (x,hl) (pridejHloubku (hl+1) r)

-- vhledem na to, ze tady nepredavame nemennou funkci, ale konkretni hodnoty hl, nejde pouzit 
--	trik s pomocnou funkci z mapTree2'


-- 2b. Ocislovat vrcholy zleva, moznosti
ocislujT :: Tree2 a -> Tree2 (a,Int)
-- a) pocitame (opakovane) velikost leveho podstromu; mene vhodne
-- b) krome stromu interni funkce vydava prvni nepouzite cislo, tj. predavani stavu
ocislujT tr = fst (ocislujT' 1 tr)

ocislujT' n Void = (Void, n)
ocislujT' n (Node l x r) = (Node l0 (x,n1) r0, n2)
  where (l0,n1) = ocislujT' n      l
        (r0,n2) = ocislujT' (n1+1) r

tc1 = ocislujT (mapTree2 (+10) tree2a)

-- Pokud mame funkce fL a fR :: Int -> Tree2 a -> (Tree2 a,Int), ktere odpovidaji vnorenym volanim
--  na podstromy, a mame pripadne i fX::Int -> a -> (a,Int), potom zpusob cislovani muzeme
--  vyjadrit funkcionalnim parametrem do obecne rekurze. 
--  Funkce fX je casto "inline-ovana".
-- (\ fL fX fR -> let (l0,n1) = fL n l; (x0,n2) = fX n1 x; (r0,n3) = fR n2 r in (Node l0 x0 r0,n3)) 



-- 3. findT :: (...) => a -> Tree2 a -> Maybe a
findT z Void = Nothing
findT z (Node l x r) 
  | z == x    = Just x
  | z <  x    = findT z l
  | otherwise = findT z r
  
-- 3a. findT' :: Eq a => (a->a->Bool) -> a -> Tree2 a -> Maybe a
-- prvni argument je usporadavaci funkce, testovani na rovnost (Eq =>) porad potrebujeme

{-
-- doprogramovat
findT' cmp z Void = Nothing
findT' cmp z (Node l x r) 
  | z == x    = Just x
  | z <  x    = findT' cmp z l
  | otherwise = findT' cmp z r

-}

{-
3b. upravit 3 a 3a na vyhledavani hodnoty (typu b) podle klice (typu a)

3c. Vyhledavani pro dvouslozkove klice (a,b)
lookup2 :: (a,b) -> Treex .. -> Maybe ...
-- Apl: pro hranu v orientovanem grafu zjistujeme jeji cenu

4. safeHead :: [a] -> ...
Vraci hlavu seznamu, ale bezpecne. Nespadne pro prazdny seznam (a neco  vrati).

5. maybe2sez :: Maybe a -> [a]
Vraci nejvys jednoprvkovy seznam.

6. mapMaybe :: (a->b) -> Maybe a -> Maybe b
-- map pro nerekurzivni typ
mapMaybe f Nothing  = undefined
mapMaybe f (Just a) = Just (undefined)

7. mapEither :: ... -> Either a b -> Either c d
-- Typ Either ma dva typove argumenty
mapEither ... (Left  x) = ...
mapEither ... (Right y) = ...

8. Nasobeni matic, kdyz mame sks/2: skalarni soucin
 - reprezentace vstupu , chytre
 - dalsi maticove operace
sks xs1 xs2 = sum (zipWith (*) xs1 xs2)

nasobM mat1 mat2 = ...
-- Q: jakou strukturu rekurze pouzijeme
-- Druha matice se zpracovava po sloupcich. Co s tim a kdy a pro koho (a moznosti).

9. 
a) Zjistit, zda ma dana instance problemu Batohu reseni. 
batoh1 :: Integer -> [Integer] -> Bool
b) Najit jedno reseni
batoh2 :: Integer -> [Integer] -> Maybe [Integer]
c) generovat rostouci posloupnost moznych souctu 
c1) aproximace reseni: odstranovat blizke soucty



----------------------------------------------
z minula: cv. 10

5. merge :: (a->a->Bool) -> [a] -> [a]
Merge z mergesortu. Fnc. arg. predava porovnavani.
- Pro procviceni @

(5b. mergesort, sude, liche, rozdel ... )

6. testovani komutativity:
testKom :: Num b => (a->a->b) -> [(a,a)] -> Bool
Testuje na danem seznamu (dvojic) vstup, jestli zadana operace je komutativni.

Co se pripadne hodi:
6a. and :: [Bool] -> Bool  - z prelude
and/1 je n-arni and

6b. all :: (a-> Bool) -> [a] -> Bool	-- z prelude
all/2 vraci, jestli pro vsechny prvky plati podminka
all even [2,4,0,-2]
 -> True
- and pomoci all

-- podobne:
or :: [Bool] -> Bool	-- z prelude
 - n-arni or
any :: (a-> Bool) -> [a] -> Bool	-- z prelude
 - aspon pro jeden prvek plati podminka

z cv., Q: jak je definovano: and []
A: Vhodne, aby to davalo smysl. A analogicky k "or []", coz je prazdna klauzule, 
kterou znate z logiky. 
Deklarativne chceme, aby: or xs == or [] || or xs . 
 -- podrobneji: or xs == or ([]++xs) == or [] || or xs
Tj. "or []" je neutralni prvek pro binarni (||).


7. lookup1: vyhledavani klice, kdyz tam je 
lookup1 :: a -> [(a,b)] -> b
- nepokryty vzor: behova chyba

> lookup1 x ((y,val):ys) | x==y = val
>                        | True = lookup1 x ys

- pouziti: prekladova tabulka pro Cezarovu sifru (posun pismena o 3), 
	preklad pomoci map/2

- tabulkaCezar vyrobi prekladovou tabulku, s danym posunutim: zip
- sifrujCezar sifruje podle tabulky: map + lookup1
- tabulkaDesifr: map
  - Cv: premenit sifrovaci tabulku na desifrovaci ; pomoci map
- cyklPosun n xs: "pootoci" dany retezec xs o n znaku (smerem dopredu)
- a klasicky deklarativni test: ta2 (ta1 txt) == txt 
    ; tj. sifrovani a nasledne desifrovani vrati puvodni text (a jako slozeni funkci je identita)

> tabulkaCezar :: Int -> [a] -> [(a,a)]  	-- vyrobi tabulku
> tabulkaCezar n xs = zip xs (cyklPosun n xs)

> sifrujCezar :: Eq a => [(a,b)] -> [a] -> [b]	-- typ je obecny, az pri pouziti je b = String
> sifrujCezar tab plainText = map (\ x -> lookup1 x tab) plainText

> cyklPosun :: Int -> [a] -> [a]
> cyklPosun n xs = drop n xs ++ take n xs  -- {n>=0}

> tabulkaDesifr :: [(a,b)] -> [(b,a)]
> tabulkaDesifr tab = map (\(x,y) -> (y,x)) tab

> tabulkaCezar3 :: [(Char,Char)]
> tabulkaCezar3 = tabulkaCezar 3 "abcdefghijklmnopqrstuvwxyz"


> ta1 text = sifrujCezar (tabulkaCezar3 ) text
> ta2 text = sifrujCezar (tabulkaDesifr tabulkaCezar3) text


8. Nasobeni matic, kdyz mame sks/2: skalarni soucin
 - reprezentace vstupu , chytre
 - dalsi maticove operace



----------------------------------------------------------
 

%%%%%%%%%%%%%%%%%%%%
% souhrn: co jste si vyzkouseli: cv. 11
% - uzivatelske typy, stromy (znova)
%   - jejich zpravovani
% - predavani stavu
% - obohaceni struktury (a odebrani pridanych informaci)

------------------------------
-- ruzne
suma1 :: [Integer] -> Integer
suma1 [] = 0
suma1 (x:xs) = x + suma1 xs

length1 :: [a] -> Integer
length1 [] = 0
length1 (x:xs) = 1 + length1 xs



-----------------------------------------------
Z minulych let:

- klouzavy prumer ze 3
  - klouzavy prumer z n
- mergesort, sude, liche, merge
- testKomut
  - kartezsky soucin
- filter
- tridy ekv.
- lookup, zjednoduseny
- automaty (2x), reprezentace DKA vs. NKA, krok
- (rychle umocnovani)
- (FFT)

%%%%%%%%%%%%%%%%%%%%%%%%%%%
% runtime
-}

