{-
% cv. 13 ; na 24.5.2017 (St) ; Jan Hric
% v. 1.0 
; *.hs

% Obsah: cv13:
- prace s Maybe:
  - safeHead: bezpecne odebrani hlavy seznamu
  - maybe na seznam
  - mapMaybe, mapEither
- (strucne seznamy)
- batoh, vic variant (2017: zcasti)
- vaha stromu

--- nestihli jsme:
- (nasobeni matic)

-}

import Complex 	-- data.Complex ; pro FFT
import Z17	-- pro testovani

-- z prednasky:

-- data Bool = False | True	-- v prelude

-- data Maybe a = Nothing | Just a
-- data Either a b = Left a | Right b

data Tree2 a = Void
             | Node (Tree2 a ) a (Tree2 a)

data NTree a = Tr a [NTree a]
	deriving Show	-- aby system mohl vypisovat (standardnim zpusobem)

{-
Q:
-}

-- testovaci data:
treeN = Tr 1 [Tr 2 [], 
              Tr 3 [Tr 4 [] ]
             ]
-- testovaci strom ma konkretni typ :: NTree Integer


{-
Nastaveni:
:set +t	        -- vypisuje typ
:set +s         -- vypisuje cas a pamat
:type vyraz	-- vypise typ vyrazu 

Naprogramujte:

1. Strucne seznamy: pytagorejske trojice {(x,y,z)|x^2+y^2=z^2 & x<y & z<=1000}, do 1000
pyth3 n = [... |...]

2. fold pro Tree2 a
foldT2 :: (...) -> (...) -> Tree2 a -> b

2a. Ve strome jsou ulozeny klice a frekvence vyskytu. Aplikujte foldT2 na Tree2 (key,Int) a spocitejte celkovou vahu stromu (=sum(hloubka*frekvence))

- idiom/navrhovy vzor v imp. jazycich: aktivni konstruktory: buduji pozmenenou nebo ozdobenou strukturu 
  - napr. udrzuji informaci o poctu prvku ve strukture
  - tvori _usporadany_ seznam misto neusporadaneho

3. scan-like funkci pro Tree2. Prochazi strom a transformuje hodnoty podstrom podle zadan funkce.
Strukturu stromu ponecha, vytvorene hodnoty zpracujeme nasledne foldT2.

3a. Aplikace: chcete kontrolovat, zda strom splnuje haldovou podminku.

3b. Aplikace: chcete kontrolovat, zda strom splnuje usporadani pro BVS

-}

-- 4. batoh
-- a) Zjistit, zda ma dana instance problemu Batohu reseni. 
-- Instance: velikost batohu a seznam kladnych (ruznych) cisel
-- batoh1 :: Integer -> [Integer] -> Bool
-- b) Najit jedno reseni
-- batoh2 :: Integer -> [Integer] -> [[Integer]]
-- c) generovat rostouci posloupnost moznych souctu 
-- c1) aproximace reseni: odstranovat blizke soucty

-- pouze rozhodnuti ::Bool
batoh1 0 _ = True
batoh1 _ [] = False
batoh1 b (x:xs) = batoh1 (b-x) xs || batoh1 b xs
-- funguje aj bez testu na zaporna cisla, ale je to neoptimalni

tb1 = batoh1 100000 [10000..10020] -- false
tb2 = batoh1 100060 [10000..10020] -- true

-- vsechna reseni, presne
-- treti arg. je akumulator aktualniho obsahu batohu
batoh2 n xs = batoh2a n xs []
  where
  batoh2a 0 _ acc = [acc]  -- vydavam 1 reseni
  batoh2a _ [] _  = []
  batoh2a b (x:xs) acc = batoh2a (b-x) xs (x:acc) ++ batoh2a b xs acc  -- spojuju seznamy reseni
    -- b muze byt zaporne

batoh21 n xs = batoh2a n xs []
  where
  batoh2a 0 _ acc = [acc]
  batoh2a _ [] _  = []
  batoh2a b (x:xs) acc 
    | b<=0 = []     -- pri zapornem b koncime, 0 je osetrena vyse
    | otherwise = batoh2a (b-x) xs (x:acc) ++ batoh2a b xs acc

-- dva zpusoby orezani: 
-- 1) volam s b<0 a testuji vstup
-- 2) testuji pred volanim, typicky vhodnejsi (mene volam, pri minimalizaci prochazim jen pripustne)

batoh3 n xs = batoh3a n (zbytky xs) []
  where
  batoh3a 0 _ acc = [acc]
  batoh3a _ [] _  = []
  batoh3a b ((x,sum):xs) acc = (if b>=x then batoh3a (b-x) xs (x:acc) else []) ++ 
	if b > sum then [] else batoh3a b xs acc
     -- testy z obou stran: s pridanym prvkem pretece kapacita resp. s vynechanym prvkem se nenaplni
     -- hranicni pripady jeste vyvolaji rekurzi

zbytky [] = []	-- soucet cisel vcetne x a za nim
zbytky (x:xs) = let z = zbytky xs in
	case z of
	  [] -> [(x,x)]
	  ((p,sum):zb1) -> (x,sum+x):(p,sum):zb1

-- optimalizacni, min delta
batoh4 b [] = b
batoh4 b (x:xs) = 
	if x<=b then min (batoh4 (b-x) xs) (batoh4 b xs)
	  else batoh4 b xs
-- pokud pocitam jedno minimum, je to OK

{-
--5. definice instance Num Z17 (v modulu/souboru z17)


module Z17 where

--data Z17 = Z17 Int
newtype Z17 = Z17 Integer
	deriving (Eq,Ord,Read,Show)

c17 = 17::Integer

instance Num Z17 where
  (+) = lift2Z17 (+)
  (-) = lift2Z17 (-)
  (*) = lift2Z17 (*)
  negate = mapZ17 negate
  --fromInt x = Z17 (x `mod` c17)
  fromInteger x = Z17 (x `mod` c17)

  abs    = undefined
  signum = undefined


mInv x = head [ Z17 inv | inv <- [1..c17], x * Z17 inv == 1]

mapZ17 f(Z17 x) = Z17 (f x `mod` c17)
lift2Z17 op (Z17 x) (Z17 y) = Z17 ((x `op` y) `mod` c17)

-------------
-}

tz1 = (mInv 2, mInv (2^7), mInv 3, mInv (3^15), mInv (3^16), mInv (3^8))

{-

6. FFT
import Complex 	-- data.Complex
import Z17  -- modul pro zbytkove tridy Z_17
  --  import Data.Maybe
-}

-- FFT
fft :: Num a => a -> [a] -> [a]
fft _ [x] = [x]		
fft e xs  = vs	where
	(sude,liche) = rozdel xs
	vs1 = fft (e*e) sude
	vs2 = fft (e*e) liche
	slozka2 = zipWith (*) vs2 (iterate (e*) 1)
	vs  = zipWith (+) vs1 slozka2 ++ zipWith (-) vs1 slozka2
	vs0 = zipWith3 (\s l ei->s+l*ei) vs1 vs2 (iterate (e*) 1) ++
	     zipWith3(\s l ei->s-l*ei) vs1 vs2 (iterate (e*) 1)    -- varianta

omega n = cos (2*pi/n) :+ sin(2*pi/n) -- k FFT, v Complex
-- magnitude :: (RealFloat a) => Complex a -> a
-- cis :: RealFloat a => a -> Complex a  ; in Data.Complex ; kompl. 1 s danym uhlem

-- deli na (sude, liche)
rozdel []      = ([],[])
rozdel (z@[x]) = (z,[])
rozdel (x1:x2:xs) = (x1:xs1,x2:xs2)
  where (xs1,xs2) = rozdel xs


test_fft1 = fft (Z17 4) [0,0,0,1]
test_fft2 = fft (Z17 2) [0,1,0,0,0,0,0,0]
test_fft3 = fft (0:+1)  [0,1,0,0]	-- complexni c.
test_fft4 = fft (cis (pi/4)) [0,1,2,3,4,3,2,1]	-- e=omega_8, skoro realne vysledky
test_fft5a xs = fft (mInv 2) $ fft (Z17 2) xs
test_fft5b = test_fft5a [1,2,3,4,5,6,7,8]  -- vychazi pronasobeno delkou (=8)
test_fft5 = and [({-xs,test_fft5a xs,-} map (*8) xs== test_fft5a xs) | xs<-genFFT8]
genFFT8 :: [[Z17]]  -- par nahodne zvolenych dat
genFFT8 = [map Z17 [x0,x1,3,4,x4,x5,0,x7] | x0<-[0..2], x1<-[1..6], x4<-[2,6,10],
	x5<- [1,3..17], x7<-[0,2..14] ]

{-

7. Huffmanovo kodovani:
- stavba stromu
- prevod stromu na kodovaci tabulku (pro encryption) 2x
- encryption
- decryption
- (pocitani frekvenci, tj. histogramu)

-- huffmanovo kodovani: optimalni, hladovy alg.
-- vzdaleny ;-) cil
{- test_HDE s = let t = mkHTree $ freq s
in s == (dec t $ enc (hstrom2tab t) s)
-}
data HStrom a = HL a
  | HV (HStrom a) (HStrom a)
hstrom2tab :: HStrom (Char {-,Int-}) -> [(Char,String)]
hstrom2tab (HL(c)) = [(c,"")]
hstrom2tab (HV l r) =
map (\(c,kod)->(c,0:kod))
(hstrom2tab l)
++
map (\(c,kod)->(c,1:kod))
(hstrom2tab r)
-- volani> hs2t "" strom -- akumulator
hs2t kod (HL(c,"")) = [(c,kod)]
hs2t kod (HV l r) =
hs2t (kod++"0") l ++ hs2t (kod++"1") r
enc :: (Eq a,Show a) => [(a,[b])] -> [a] -> [b]
enc tab [] = []
enc tab (x:xs) =
enc1 tab x ++ enc tab xs
where
enc1 [] x =
error("enc: missing code for:"++show x)
enc1 ((x1,kod):tab) x =
if x==x1 then kod
else enc1 tab x
6
enc2 tab xs =
concat(map(\x -> snd(head(filter (f x) tab))) xs)
where f x = \(x1,_kod) -> x==x1 -- x: lambda-lifting
-- f x = (x==).fst -- varianta
-- = concat $ map (\x -> snd $ head $ filter f tab) xs
-- concat [] = [] -- v Prelude
-- concat (x:xs) = x ++ concat xs
-- anebo: concat xss = foldr (++) [] xss
7
dec :: HStrom a -> [Char] -> [a]
dec strom [] = []
dec strom inp = c : dec strom inp1
where
(c, inp1) = dec1 strom inp
dec1 :: HStrom a -> [Char] -> (a,[Char])
dec1 (HL c) inp = (c,inp)
dec1 (HV l r) (0:inp) = dec1 l inp
dec1 (HV l r) (1:inp) = dec1 r inp
dec1 (HV l r) ( x :inp) = error ("dec: bad code:"++show x)
dec1 (HV l r) [] = error "dec: unexpected EOF"
dec2 :: HStrom a -> [Char] -> [a]
dec2 strom inp = case x of
Nothing -> []
-- interni chyba: nic se nedekoduje
Just (c,inp1) -> c : dec strom inp1
where
x = dec1 strom inp
dec1 :: HStrom a -> [Char] -> Maybe (a,[Char])
dec1 (HL c) inp = Just (c,inp)
dec1 (HV l r) (0:inp) = dec1 l inp
dec1 (HV l r) (1:inp) = dec1 r inp
dec1 (HV l r) ( x :inp) = Nothing
dec1 (HV l r) [] = Nothing
-- pozn: odebirana cast je dana kontextem
{-
data Maybe a = Nothing
| Just a
deriving (Eq, Show)
-}
8
mkHTree :: [(Char,Int)] -> HStrom Char
mkHTree xs = faze5
where
cmp (c1,f1) (c2,f2) = f1<=f2
-- cmp = \(c1,f1) (c2,f2) -> f1<=f2
faze1 = sort cmp xs
faze2 = map (\(c,f) -> (HL c, f)) faze1
faze3 = iterate spoj faze2
faze4 = dropWhile (\x -> length x > 1) faze3
faze5 = fst $ head $ head faze4
spoj [x] = [x]
spoj ((c1,f1):(c2,f2):xs) = insert cmp (HV c1 c2,f1+f2) xs
sort cc xs = foldr (insert cc) [] xs
insert cc x [] = [x]
insert cc x vs@(y:ys)
| xccy = (x:vs)
| True = y:insert cc x ys
9
freq :: String -> [(Char,Int)] -- histogram
freq xs = foldr ordBagUnion [] $ map (\x->[(x,1)]) xs
-- O(n^2) :-(
ordBagUnion [] ys = ys
ordBagUnion xs [] = xs
ordBagUnion xx@((x,fx):xs) yy@((y,fy):ys)
| x < y = (x,fx) :ordBagUnion xs yy
| x == y = (x,fx+fy):ordBagUnion xs ys -- memory leak
| x > y = (y,fy) :ordBagUnion xx ys
foldDvoj f e [] = []
foldDvoj f e xs =
(head.head.dropWhile((1<).length).iterate(spojDvoj f))xs
where
spojDvoj f (x1:x2:xs) = f x1 x2 : spojDvoj f xs
spojDvoj f xs = xs
freq2 xs = foldDvoj ordBagUnion [] $ map (\x->[(x,1)]) xs
testFreq k c = [s|s<-varOpak1 k [a..c],
let s1=s,
freq2 s /= freq s ]



--------------------
--- cv 12
1. map pro NTree
mapNTree :: (a->b) -> NTree a -> NTree b
mapNTree  f (Tr x ts) = Tr (f x) (map (mapNTree f) ts)
-- variantne:         = Tr (f x) $ map (mapNTree f) ts

1a. pridejDelkuNT :: NTree a -> NTree (a,Int)
ke kazdemu vrcholu prida pocet podstromu

pridejDelkuNT (Tr x ts) = Tr (x, length ts) $ map pridejDelkuNT ts

Q: jde napsat pridejDelkuNT jako instance mapNTree?
A: Nejde. 
Z typu f::a->b v mapNTree vidime, ze hodnota vysledku musi vzniknout pouze z x (a samostatne). :-(

Zobecnime:
-}
mapNTreeA :: (NTree a -> b) -> NTree a -> NTree b
  -- hodnotu b muzu ziskat zpracovanim celeho podstromu, ale samostatne: 
  -- pr: pocet podstromu, hloubka, velikost (pocitana opakovane a samostatne :-( ), ...
mapNTreeA f t@(Tr x ts) = Tr (f t) $ map (mapNTreeA f) ts

pridejDelkuNT2 = mapNTreeA (\t@(Tr x ts) -> (x,length ts))

-- test
tc1 = pridejDelkuNT2 treeN

-- 2. datovy typ pro vetne stromy, rozlisuji leve a prave potomky
data VetneStromy a = VS [VetneStromy a] a [VetneStromy a]

dataVS = VS [VS [] "Ema" [] ] 
            "ma" 
            [VS [VS [] "malou" []]
                "misu"
                [VS [] "masa"  []],
             VS [] "dnes" [],
             VS [] "doma" []
            ]
           :: VetneStromy String  -- data maji konkretni typ

-- 2a. datovy typ pro regularni vyrazy
data RV a = Lambda
          | Empty
          | Con a               -- pismeno
          | Seq (RV a) (RV a)   -- sekvence, varianta jako operator napr (:.)
          | Alt (RV a) (RV a)   -- alternativa, (:+)
          | Star (RV a)

dataRV =     Lambda `Alt` (Con 'b' `Seq` Star (Con 'a'))  -- reg. vyraz l+a.b*
-- dataRV' = Lambda :+ (Con 'b' :. Star (Con 'a'))        -- kdyby jsme byvali pouzili operatory
{-  -}

-- z minula:
-- 3. findT, vyhledavani prvku ve binarnim vyhledavacim stromu
      -- trida Ord a obsahuje porovnavani (<) i rovnost (==)
findT :: Ord a => a -> Tree2 a -> Maybe a
findT z Void = Nothing
findT z (Node l x r) 
  | z == x    = Just x
  | z <  x    = findT z l
  | otherwise = findT z r
  
-- 3a. findT' :: Eq a => (a->a->Bool) -> a -> Tree2 a -> Maybe a
-- prvni argument je usporadavaci funkce, testovani na rovnost (Eq =>) porad potrebujeme

{-
-- doprogramovat
findT' cmp z Void = Nothing
findT' cmp z (Node l x r) 
  | z == x    = Just x
  | z <  x    = findT' cmp z l
  | otherwise = findT' cmp z r
-}

{-
(3b. upravit 3 a 3a na vyhledavani hodnoty (typu b) podle klice (typu a) )
lookupT ::    Ord a => a -> Tree2 (a,b) -> Maybe b
-- analogicke k lookup v seznamu
-- lookup ::  Eq a  => a -> [(a,b)]     -> Maybe b

(3c. Vyhledavani pro dvouslozkove klice (a,b) )
-- Motivace: ke hrane v gragu (zadanou dvema vrcholy), hledate informace, napr. cenu.
-- Muzete pouzit lookup/lookupT, ale to prohledavate cely seznam hran
lookup2  :: (a,b) -> [(a,[(b,c)])] -> Maybe c
lookup2T :: (a,b) -> Tree2 (a, Tree2 (b,c)) -> Maybe c
-- misto : lookupT :: (a,b) -> Tree2 ((a,b),c) -> Maybe c
-- Apl: pro hranu v orientovanem grafu zjistujeme jeji cenu

-- spojovani "zabalenych" hodnot (v Maybe) je pracne, viz dale
lookup2T (a,b) t 
     | step1 == Nothing  = Nothing 
     | otherwise         = findT b (unJust step1)	-- (A), find podle druheho podklice
  where step1 = findT a t        -- find podle prvniho podklice
        unJust (Just x) = x
-- (A) 1: findT muze vratit opet Nothing
--     2: step1 je zabaleny v Just, to uz vime, ale potrebujeme pro findT vybalit
--     3: opacny test (step1 == Just _) nejde napsat, na rozdil od Prologu. 
--        Podtrzitko je vzor, ne hodnota/promenna

4. safeHead :: [a] -> Maybe a
Vraci hlavu seznamu, ale bezpecne. Nespadne pro prazdny seznam (a neco vrati).
-- podobne bezpecne safeTail, deleno, log, sqrt ...
safeHead (x:_) = Just x
safeHead _     = Nothing

5. maybe2sez :: Maybe a -> [a]
Vraci nejvys jednoprvkovy seznam.
maybe2sez Nothing  = []
maybe2sez (Just x) = [x]

6. mapMaybe :: (a->b) -> Maybe a -> Maybe b
-- map pro nerekurzivni typ
mapMaybe f Nothing  = Nothing
mapMaybe f (Just x) = Just (f x)

7. mapEither :: (a->c) -> (b->d) -> Either a b -> Either c d
-- Maybe ma jeden typovy parametr, potrebovali jsme jednu funkci
-- Typ Either ma dva typove argumenty, potrebujeme dve funkce
-- --Q: jake funkce potrebuju?
mapEither f g (Left  x) = Left  $ f x
mapEither f g (Right y) = Right $ g y
-- pozn. mapEither ponechava konstruktory, podobne jako i jine map-y

-- podobne mapPair :: (a->c) -> (b->d) -> (a,b) -> (c,d)
-- Q; jake funkce potrebuju?
mapPair f g (x,y) = (f x, g y)

-- k cemu je mapEither dobre:
-- mapKosik xs = map (spracujJablka `mapEither` spracujHrusky) xs
-- mapEither vytvari transformacni funkci, podobne jako flip, curry, uncurry (z prednasky), ale 
--   dostava 2 funkce

-- transformacni funkce flipEither: vymeni Left a Right; mapEither to nedokaze (neni k tomu urcena)
-- flipEither transformuje data, ne funkce
flipEither :: Either a b -> Either b a
flipEither (Left  x) = Right x
flipEither (Right y) = Left  y


-- a podobne obecne zpracovani maybe :: (a->b) -> b -> Maybe a -> b
-- zadam, jak spracuju platnou hodnotu x::a na ::b a jak spracuju Nothing na konstantu ::b
-- vlastne foldMaybe
--    bude pozdeji na prednasce u fold
maybe just nothing Nothing  = nothing  -- vraci konstantu
maybe just nothing (Just x) = just x   -- vraci zpracovanou vnitrni hodnotu
-- male pocatecni pismena jsou umyslne, predavane zpracovavaci funkce

-- 7a. aplMaybe .. aplikace f na zabalenou hodnotu
-- 	aplMaybe se postara o rozbaleni ...
-}
aplMaybe :: (a -> Maybe b) -> Maybe a -> Maybe b
aplMaybe f Nothing	= Nothing
aplMaybe f (Just x)	= f x	-- muze vratit i Nothing
-- aplMaybe je bind (>>=) z monady Maybe, az na prehozene parametry; bude

-- s vyuzitim maybe/3 vyse
-- aplMaybe' f mx = maybe f Nothing mx

-- 7b. slozeni maybe-funkci f a g v compMaybe
-- aplMaybe umoznuje zretezit volani funkci
compMaybe :: (b->Maybe c) -> (a-> Maybe b) -> a -> Maybe c
compMaybe f g x = f `aplMaybe` g x

-- 7c. "podminena" rovnost: pokud jsou obe hodnoty platne (v Maybe), musi se rovnat
--     "podminena" ruznost: ... musi byt ruzne 
-- podminena rovnost [(Maybe a , Maybe a)] -> Bool
podmRovn :: Eq a => [(Maybe a , Maybe a)] -> Bool
podmRovn xs = and $ map (uncurry f) xs
  where f (Just x) (Just y) = x==y
        f _        _        = True
-- pouziti uncurry: f je funkce dvou argumentu, ale chceme ji pouzit na dvojice (v map)

podmRuzn :: Eq a => [(Maybe a , Maybe a)] -> Bool
podmRuzn xs = and $ map (uncurry f) xs
  where f (Just x) (Just y) = x/=y
        f _        _        = True

{-
-- aplikace: pri barveni grafu, kontroluju castecne obarveni na hranach. Barvy vybiram pomoci 
   lookup z castecneho obarveni. Pokud jsou oba vrcholy obarveny, musi byt barvy ruzne.
   Pri obarveni dalsiho vrcholu zkontroluju jeho obarveni vuci jeho okoli. 
     (Metoda Generuj a testuj, zde testujeme prubezne, kvuli efektivite.)
-- Typicky je vhodnejsi predpocitat si povolene barvy.
-- Pomijime otazku, ktery vrchol vybrat pro obarvovani (a zkouset na nem 
     vsechny resp. povolene barvy).
--

- aplikace strucnych seznamu:
(8a. Odmocniny z 1 v konecnych okruzich, pro diskretni FFT. "Ze ivota")
Hledame prvocislo p (tj. modulo) ve tvaru k.2^l+1 a odmocninu w (nebo generator g), t.
w^(2^l) = 1 mod p, (a g^k=w mod p, a pritom n=2^l je nejvetsi mocnina s touto vlastnosti).
Overte, ze mensi mocniny w a g nejsou kongruentni s 1 mod p.
-- napriklad: p=17, k=1, n=16, pro l=4 je w=g=3, pro l=3 je g=2
-- viz M.Mares, skripta k ADS2, kap. FFT

-- expmod pocita x na exp modulo m, 
--   s rychlym umocnovanim a "hladovym" modulo
expmod x exp m = undefined

--

-}

-- 9. Kartezsky soucin seznamu, trade-off, z prednasky
kartn1 :: [[a]] -> [[a]] 
kartn1 [] = [[]] 
kartn1 (xs:xss) = [x:ks | x<-xs, ks<-kartn1 xss]  -- vic casu

kartn2 :: [[a]] -> [[a]] 
kartn2 [] = [[]] 
kartn2 (xs:xss) = [x:ks | ks<-kartn2 xss, x<-xs]  -- vic pameti, pamatuje si mezivysledky

tkart = [[1..10]| _<-[1..6]]

-- (10.0 Damy na sachovnici je typicka uloha pro generuj a testuj)


{-


------------
-- z cv. 11
--
8. Nasobeni matic, kdyz mame sks/2: skalarni soucin
 - reprezentace vstupu , chytre
 - dalsi maticove operace
sks xs1 xs2 = sum (zipWith (*) xs1 xs2)

nasobM mat1 mat2 = ...
-- Q: jakou strukturu rekurze pouzijeme
-- Druha matice se zpracovava po sloupcich. Co s tim a kdy a pro koho (a moznosti).



----------------------------------------------
z minula: cv. 10

5. merge :: (a->a->Bool) -> [a] -> [a]
Merge z mergesortu. Fnc. arg. predava porovnavani.
- Pro procviceni @

(5b. mergesort, sude, liche, rozdel ... )

6. testovani komutativity:
testKom :: Num b => (a->a->b) -> [(a,a)] -> Bool
Testuje na danem seznamu (dvojic) vstup, jestli zadana operace je komutativni.

Co se pripadne hodi:
6a. and :: [Bool] -> Bool  - z prelude
and/1 je n-arni and

6b. all :: (a-> Bool) -> [a] -> Bool	-- z prelude
all/2 vraci, jestli pro vsechny prvky plati podminka
all even [2,4,0,-2]
 -> True
- and pomoci all

-- podobne:
or :: [Bool] -> Bool	-- z prelude
 - n-arni or
any :: (a-> Bool) -> [a] -> Bool	-- z prelude
 - aspon pro jeden prvek plati podminka

z cv., Q: jak je definovano: and []
A: Vhodne, aby to davalo smysl. A analogicky k "or []", coz je prazdna klauzule, 
kterou znate z logiky. 
Deklarativne chceme, aby: or xs == or [] || or xs . 
 -- podrobneji: or xs == or ([]++xs) == or [] || or xs
Tj. "or []" je neutralni prvek pro binarni (||).


7. lookup1: vyhledavani klice, kdyz tam je 
lookup1 :: a -> [(a,b)] -> b
- nepokryty vzor: behova chyba

> lookup1 x ((y,val):ys) | x==y = val
>                        | True = lookup1 x ys

- pouziti: prekladova tabulka pro Cezarovu sifru (posun pismena o 3), 
	preklad pomoci map/2

- tabulkaCezar vyrobi prekladovou tabulku, s danym posunutim: zip
- sifrujCezar sifruje podle tabulky: map + lookup1
- tabulkaDesifr: map
  - Cv: premenit sifrovaci tabulku na desifrovaci ; pomoci map
- cyklPosun n xs: "pootoci" dany retezec xs o n znaku (smerem dopredu)
- a klasicky deklarativni test: ta2 (ta1 txt) == txt 
    ; tj. sifrovani a nasledne desifrovani vrati puvodni text (a jako slozeni funkci je identita)

> tabulkaCezar :: Int -> [a] -> [(a,a)]  	-- vyrobi tabulku
> tabulkaCezar n xs = zip xs (cyklPosun n xs)

> sifrujCezar :: Eq a => [(a,b)] -> [a] -> [b]	-- typ je obecny, az pri pouziti je b = String
> sifrujCezar tab plainText = map (\ x -> lookup1 x tab) plainText

> cyklPosun :: Int -> [a] -> [a]
> cyklPosun n xs = drop n xs ++ take n xs  -- {n>=0}

> tabulkaDesifr :: [(a,b)] -> [(b,a)]
> tabulkaDesifr tab = map (\(x,y) -> (y,x)) tab

> tabulkaCezar3 :: [(Char,Char)]
> tabulkaCezar3 = tabulkaCezar 3 "abcdefghijklmnopqrstuvwxyz"


> ta1 text = sifrujCezar (tabulkaCezar3 ) text
> ta2 text = sifrujCezar (tabulkaDesifr tabulkaCezar3) text



----------------------------------------------------------
 

%%%%%%%%%%%%%%%%%%%%
% souhrn: co jste si vyzkouseli: cv. 13
% - batoh
% - map, fold
% - 
% 
% 
%   

------------------------------
-- ruzne


-----------------------------------------------

%%%%%%%%%%%%%%%%%%%%%%%%%%%
% runtime
-}

